Rem
bbdoc:	Interface for enumerator objects
about:	Enumerators provide a standardized interface for looping over a number of connected elements.

		<p>A correctly implemented enumerator allows for looping over the elements in a <tt>ForEach</tt> loop.</p>
End Rem
Type IEnumerator Abstract

	Rem
	bbdoc:	Checks if there is another element left
	returns: <tt>True</tt> if there is another element to be enumerated over, otherwise <tt>False</tt>.
	about:	This should be a read-only operation.
	End Rem
	Method hasNext:Int() Abstract
	
	Rem
	bbdoc:	Gives the next element of the collection
	returns: A valid object as long as #hasNext returns <tt>True</tt>.
	about:	Before returning the next object this has to increment the internal pointer/counter
			to the next element in the collection first.
	End Rem
	Method nextObject:Object() Abstract

End Type